childProcess = require "child_process"

# Streamed output
module.exports.executeCommand = (command, callbacks = null) ->
  parts = command.split " "
  command = parts.shift()
  args = parts
  
  spawnedProcess = childProcess.spawn command, args
  
  spawnedProcess.stdout.setEncoding "utf8"
  spawnedProcess.stdout.on "data", (data) -> process.stdout.write data
  
  spawnedProcess.stderr.setEncoding "utf8"
  spawnedProcess.stderr.on "data", (data) -> process.stdout.write data
  
  if callbacks?.exit?
    spawnedProcess.on "exit", exitCallback
  
# Buffered output
module.exports.runCommand = (command) ->
  spawnedProcess = childProcess.exec command, encoding: "utf8", (error, stdout, stderr) ->
    process.stdout.write error if error isnt null
    process.stdout.write stdout if stdout isnt null
    process.stdout.write stderr if stderr isnt null
    
# Buffered output
module.exports.runFile = (file) ->
  parts = file.split " "
  file = parts.shift()
  args = parts
  spawnedProcess = childProcess.execFile file, args, encoding: "utf8", (error, stdout, stderr) ->
    console.log error if error isnt null
    console.log stdout if stdout isnt null
    console.log stderr if stderr isnt null